﻿Imports Leap

Public Class LeapListener
    Inherits Listener
    Private fingersCount As Integer
    Public Overrides Sub OnConnect(ctlr As Controller)
        ctlr.Config.SetFloat("Gesture.Swipe.MinLength", 10)
        ctlr.Config.SetFloat("Gesture.Swipe.MinVelocity", 100)
        ctlr.Config.Save()
        ctlr.EnableGesture(Gesture.GestureType.TYPESWIPE)
    End Sub

    Public Overrides Sub OnFrame(ctlr As Controller)
        Dim currentFrame As Frame = ctlr.Frame
        If (Not currentFrame.Hands.Empty) Then

            Dim firstHand As Hand = currentFrame.Hands(0)
            Dim fingers As FingerList = firstHand.Fingers

            If (Not fingers.Empty) Then
                Dim gestures As GestureList = currentFrame.Gestures
                For Each gst As Gesture In gestures
                    If gst.Type = Gesture.GestureType.TYPESWIPE Then
                        Dim swipe As New SwipeGesture(gst)
                        If (swipe.Direction.y > 0) Then
                            SwipeAction(fingers, SwipeDirection.Up)
                        Else
                            SwipeAction(fingers, SwipeDirection.Down)
                        End If
                        Exit For
                    End If
                Next
            End If
        End If
    End Sub

    Public Delegate Sub SwipeEvent(ByVal sd As SwipeDirection)
    Public Event LeapSwipe As SwipeEvent

    Private Sub SwipeAction(ByVal fingers As FingerList, ByVal sd As SwipeDirection)
        fingersCount = fingers.Count
        If (fingersCount = 5) Then
            Select Case sd
                Case SwipeDirection.Up
                    RaiseEvent LeapSwipe(SwipeDirection.Up)
                    Exit Select
                Case SwipeDirection.Down
                    RaiseEvent LeapSwipe(SwipeDirection.Down)
                    Exit Select
            End Select
        End If
    End Sub
End Class


