﻿Imports Leap
Imports System.Windows.Ink
Class MainWindow
    Private leap As New Controller
    Private windowWidth As Double = 1366
    Private windowHeight As Double = 768
    Private touchIndicator As New DrawingAttributes



    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        AddHandler CompositionTarget.Rendering, AddressOf Update
        touchIndicator.Width = 30
        touchIndicator.Height = 30
        touchIndicator.StylusTip = StylusTip.Ellipse
    End Sub

    Private Sub Update(sender As Object, e As EventArgs)
        paintCanvas.Strokes.Clear()
        windowWidth = Me.Width
        windowHeight = Me.Height

        Dim frame As Leap.Frame = leap.Frame
        Dim interactionBox As InteractionBox = leap.Frame.InteractionBox
        For Each Pointable As Pointable In leap.Frame.Pointables
            Dim normalizedPosition As Leap.Vector = interactionBox.NormalizePoint(Pointable.StabilizedTipPosition)
            Dim tx As Double = normalizedPosition.x * windowWidth
            Dim ty As Double = windowHeight - normalizedPosition.y * windowHeight
            Dim touchPoint As StylusPoint = New StylusPoint(tx, ty)

            Dim tips As New StylusPointCollection(New StylusPoint() {touchPoint})
            Dim touchStroke As New Stroke(tips, touchIndicator)
            paintCanvas.Strokes.Add(touchStroke)

        Next

    End Sub
End Class


