﻿Imports System.ComponentModel
Imports Leap
Public Class UpDownModel
    Implements INotifyPropertyChanged

    Private ctlr As Controller
    Private listener As LeapListener

    Public Sub New()
        ctlr = New Controller
        listener = New LeapListener
        ctlr.AddListener(listener)
        AddHandler listener.LeapSwipe, AddressOf Me.SwipeAction
    End Sub

    Private myHeight As Double

    Public Property EllipseHeight As Double
        Get
            Return myHeight
        End Get
        Set(value As Double)
            myHeight = value
            OnPropertyChanged("EllipseHeight")
        End Set
    End Property

    Private myWidth As Double
    Public Property EllipseWidth As Double
        Get
            Return myWidth
        End Get
        Set(value As Double)
            myWidth = value
            OnPropertyChanged("EllipseWidth")
        End Set
    End Property

    Private Sub SwipeAction(ByVal sd As SwipeDirection)
        Select Case sd
            Case SwipeDirection.Up
                EllipseHeight += 10
                EllipseWidth += 10

                Exit Select
            Case SwipeDirection.Down

                EllipseHeight -= 10
                EllipseWidth -= 10
                Exit Select
        End Select
    End Sub

    Public Event PropertyChanged(sender As Object, e As PropertyChangedEventArgs) Implements INotifyPropertyChanged.PropertyChanged

    Private Sub OnPropertyChanged(ByVal propertyName As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
    End Sub
End Class
